#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/signal.h>
#include <bits/sigset.h>
#include <sys/stat.h>
#include <termios.h>

#define BAUDRATE B115200            
#define PORT "/dev/ttyS1"

int serial_fd;			//serial port file descriptor
int wait_flag = 1; 		//1 while no signal received

void signal_handler_IO(int status) {
	fprintf(stderr, "sig:");
	wait_flag = 0;
}

int open_serial(void) {
    struct termios termios;
    struct sigaction saio;
	int ret = 0;
	
	if((serial_fd = open("/dev/ttyS1", O_NOCTTY | O_RDWR | O_NONBLOCK)) > -1) {
		//install the signal handler before making the device asynchronous
        saio.sa_flags = 0;
        saio.sa_restorer = NULL;
        saio.sa_handler = signal_handler_IO;
		sigemptyset(&saio.sa_mask);
        sigaction(SIGIO, &saio, NULL);

        //allow the process to receive SIGIO
        fcntl(serial_fd, F_SETOWN, getpid());
        fcntl(serial_fd, F_SETFL, FASYNC);

		bzero(&termios, sizeof(termios));
		termios.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
		termios.c_iflag = ICRNL;
		termios.c_oflag = 0;
		termios.c_lflag = ICANON;
		termios.c_cc[VMIN] = 1;
		termios.c_cc[VTIME] = 0;
		
		tcflush(serial_fd, TCIFLUSH);
		if(tcsetattr(serial_fd, TCSANOW, &termios) > -1)
			ret = 1;
	}
	
	return ret;
}

void BT_HandleInput(void) {
	int len;
	char buffer[255];
	
	if(wait_flag == 0) { 
		len = read(serial_fd, buffer, 255); 
		buffer[len] = 0x00;
		fprintf(stderr, "line[%d]: %s", len, buffer);
		wait_flag = 1;      /* wait for new input */
	}
}

int main(int argc, char **argv) {
	int bluetooth = 0;

	//open the serial port
	bluetooth = open_serial();
	
	while(1) {
		if(bluetooth) {
			BT_HandleInput();
		}
	}

	return 0;
}
